﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
/// Programing : Kambiz Dehghani
/// Site : www.SourceGozar.com
namespace TellBook
{
    public partial class frmMain : Form
    {
        public frmMain()
        {
            InitializeComponent();
        }
        public int ID1;
        DataTable datat = new DataTable();
        //مسیر دیتا بیس را مشخص میکند
        string filename = Application.StartupPath + "\\database.txt";
        private void btnAdd_Click(object sender, EventArgs e)
        {
            frmAddEdit ShowAddEdit = new frmAddEdit();
            ShowAddEdit.ShowDialog();
            ShowAddEdit.cou = 1;
            ShowList();
        }
        private void BtnExit_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }
        private void frmMain_Load(object sender, EventArgs e)
        {
            try
            {
                //چک میکند که آیا دیتا بیس وجود دارد یا نه ... اگر وجود نداشته باشد یک نمونه از دیتا بیس میسازد
                if (!File.Exists(filename))
                {
                    File.Create(filename);
                }
                else
                {
                    ShowList();
                }
            }
            catch
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
        }
        public void ShowList()
        {
            try
            {
                {
                    // آی دی را از تابع گت آی دی دریافت میکند برای این که به عنوان ردیف نمایش دهد
                    ID1 = getid();
                }
                // یک نمونه دیتا تیبل میسازد و ستون های آن را مشخص میکند... اطلاعات بانک را در اینجا تفکیک میکند و درون دیتا گرید ویو ریخته و آن را نمایش میدهد
                DataTable dt = new DataTable();
                dt.Columns.Add("ID1");
                dt.Columns.Add("Name");
                dt.Columns.Add("Family");
                dt.Columns.Add("Mobile");
                dt.Columns.Add("Address");
                //دیتا بیس را در مسیر مشخص شده میخواندو اطلاعات آن را تفکیک میکند
                StreamReader SR = new StreamReader(filename);
                string all = SR.ReadToEnd();
                SR.Close();
                string[] records = all.Split('+');
                for (int i = 0; i < records.Length - 1; i++)
                {
                    string[] cells = records[i].Split(';');
                    dt.Rows.Add(cells[0], cells[1], cells[2], cells[3], cells[4]);
                }
                //اطلاعات را در دیتا گرید ویو نمایش میدهد
                DGW.DataSource = dt;
                DGW.Columns[0].Width = 80;
                DGW.Columns[1].Width = 70;
                DGW.Columns[2].Width = 90;
                DGW.Columns[3].Width = 80;
                DGW.Columns[4].Width = 150;
                DGW.Columns[0].HeaderText = "شماره ثبت";
                DGW.Columns[1].HeaderText = "نام";
                DGW.Columns[2].HeaderText = "نام خانوادگی";
                DGW.Columns[3].HeaderText = "موبایل";
                DGW.Columns[4].HeaderText = "آدرس";
            }
            catch
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
        }
        public int getid()
        {
            //ردیف را مشخص میکند
            StreamReader sr = new StreamReader(filename);
            string all = sr.ReadToEnd();
            sr.Close();
            string[] records = all.Split('+');
            return records.Length - 1;
        }
        private void btnDelete_Click(object sender, EventArgs e)
        {
            try
            {
                if (MessageBox.Show("آیا مایلید مورد انتخاب شده حذف شود؟", "سوال(حذف)؟", MessageBoxButtons.YesNo, MessageBoxIcon.Question, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading) == DialogResult.Yes)
                {
                    //در صورتی که تعداد سطرهای جدول صفر باید بر میگردد 
                    if (DGW.RowCount <= 0) return;
                    else
                    {
                        //فایل را دریافت کرده و آن را تفکیک میکند و کلیه اطلاعات بدون اطلاعاتی که آی دی انها برابر با ایندکس میباشد را دوباره نویسی میکند 
                        int counter = 0;
                        string temp = "";
                        StreamReader sr = new StreamReader(filename);
                        string all = sr.ReadToEnd();
                        sr.Close();
                        string[] records = all.Split('+');
                        string index = DGW.CurrentRow.Index.ToString();
                        StreamWriter sw = new StreamWriter(filename);
                        for (int i = 0; i < records.Length - 1; i++)
                        {
                            string[] cells = records[i].Split(';');
                            if (cells[0] != index)
                            {
                                temp += counter
                                        + ";" + cells[1]
                                        + ";" + cells[2]
                                        + ";" + cells[3]
                                        + ";" + cells[4]
                                        + ";" + cells[5] + "+";
                                counter++;
                            }
                        }
                        sw.Write("");
                        sw.Write(temp);
                        sw.Close();
                        ShowList();
                    }
                }
            }
            catch
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
        }
        private void btnEdit_Click(object sender, EventArgs e)
        {
            try
            {
                if (DGW.RowCount > 0)
                {
                    //نمونه ای از فرم افزودن میسازد
                    frmAddEdit showAdd_Edit = new frmAddEdit();
                    showAdd_Edit.cou = 0;
                    showAdd_Edit.ID12 = Int32.Parse(DGW.CurrentRow.Cells[0].Value.ToString());
                    showAdd_Edit.txtName.Text = DGW.CurrentRow.Cells[1].Value.ToString();
                    showAdd_Edit.txtFamily.Text = DGW.CurrentRow.Cells[2].Value.ToString();
                    showAdd_Edit.txtMobile.Text = DGW.CurrentRow.Cells[3].Value.ToString();
                    showAdd_Edit.txtAddress.Text = DGW.CurrentRow.Cells[4].Value.ToString();
                    //فرم را نمایش میدهد
                    showAdd_Edit.cou = 0;
                    showAdd_Edit.ShowDialog();
                    //در اینجا تابع شو لیست را فرا خوانی میکند و منتظر بسته شدن فرم میماند که به محض بسته شدن اطلاعات را آپدیت کند
                    ShowList();
                }
            }
            catch
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
        }
        public void btnFind_Click(object sender, EventArgs e)
        {
            
            
            if (ComboFind.Text == "انتخاب کنید")
            {
                MessageBox.Show("کاربر گرامی لطفا گزینه ای را برای جستجو انتخاب نمایید", "خطا در جستجو", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
                ComboFind.Select();
                return;
            }
            try
            {
                try
                {
                    // آی دی را از تابع گت آی دی دریافت میکند برای این که به عنوان ردیف نمایش دهد
                    ID1 = getid();
                }
                catch
                {
                    MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
                }
                // یک نمونه دیتا تیبل میسازد و ستون های آن را مشخص میکند... اطلاعات بانک را در اینجا تفکیک میکند و درون دیتا گرید ویو ریخته و آن را نمایش میدهد
                DataTable dt = new DataTable();
                dt.Columns.Add("ID1");
                dt.Columns.Add("Name");
                dt.Columns.Add("Family");
                dt.Columns.Add("Mobile");
                dt.Columns.Add("Address");
                //دیتا بیس را در مسیر مشخص شده میخواندو اطلاعات آن را تفکیک میکند
                StreamReader SR = new StreamReader(filename);
                string all = SR.ReadToEnd();
                SR.Close();
                string[] records = all.Split('+');
                for (int i = 0; i < records.Length - 1; i++)
                {
                    string[] cells = records[i].Split(';');
                    int w = ComboFind.SelectedIndex + 1;
                    if (cells[w].Substring(0, txtFind.Text.Length) == txtFind.Text)
                        dt.Rows.Add(cells[0], cells[1], cells[2], cells[3], cells[4]);
                }
                //اطلاعات را در دیتا گرید ویو نمایش میدهد
                DGW.DataSource = dt;
            }
            catch
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
                
        }
        private void txtFind_TextChanged(object sender, EventArgs e)
        {
            if (ComboFind.Text == "انتخاب کنید")
            {
                MessageBox.Show("کاربر گرامی لطفا گزینه ای را برای جستجو انتخاب نمایید", "خطا در جستجو", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
                ComboFind.Select();
                return;
            }
            try
            {
                try
                {
                    // آی دی را از تابع گت آی دی دریافت میکند برای این که به عنوان ردیف نمایش دهد
                    ID1 = getid();
                }
                catch
                {
                    MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
                }
                // یک نمونه دیتا تیبل میسازد و ستون های آن را مشخص میکند... اطلاعات بانک را در اینجا تفکیک میکند و درون دیتا گرید ویو ریخته و آن را نمایش میدهد
                DataTable dt = new DataTable();
                dt.Columns.Add("ID1");
                dt.Columns.Add("Name");
                dt.Columns.Add("Family");
                dt.Columns.Add("Mobile");
                dt.Columns.Add("Address");
                //دیتا بیس را در مسیر مشخص شده میخواندو اطلاعات آن را تفکیک میکند
                StreamReader SR = new StreamReader(filename);
                string all = SR.ReadToEnd();
                SR.Close();
                string[] records = all.Split('+');
                for (int i = 0; i < records.Length - 1; i++)
                {
                    string[] cells = records[i].Split(';');
                    int w = ComboFind.SelectedIndex + 1;
                    if (cells[w].Substring(0, txtFind.Text.Length) == txtFind.Text)
                        dt.Rows.Add(cells[0], cells[1], cells[2], cells[3], cells[4]);
                }
                //اطلاعات را در دیتا گرید ویو نمایش میدهد
                DGW.DataSource = dt;
            }
            catch 
            {
                MessageBox.Show("کاربر گرامی نرم افزار با مشکل مواجعه شده است", "خطا", MessageBoxButtons.OK, MessageBoxIcon.Error, MessageBoxDefaultButton.Button1, MessageBoxOptions.RtlReading);
            }
        }
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (DGW.RowCount <= 0)
            {
                btnDelete.Enabled = false;
                btnEdit.Enabled = false;
            }
            else
            {
                btnDelete.Enabled = true;
                btnEdit.Enabled = true;
            }
        }

        private void linkLabel1_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
        {
            
        }
    }
}
